Subject: Re: [PATCH v2 tip/core/rcu 07/13] ipv6/ip6_tunnel: Apply rcu_access_pointer() to avoid sparse false positive

From: Mathieu Desnoyers <[email-masked]>
Date: Sat, 12 Oct 2013 19:42:18 +0000 (UTC)

----- Original Message -----
> From: "Hannes Frederic Sowa" <[email-masked]>
> To: "Paul E. McKenney" <[email-masked]>, "Eric Dumazet" <[email-masked]>, "Josh Triplett"
> <[email-masked]>, [email-masked], [email-masked], [email-masked], [email-masked],
> [email-masked], "mathieu desnoyers" <[email-masked]>, [email-masked], [email-masked],
> [email-masked], [email-masked], [email-masked], [email-masked], [email-masked],
> [email-masked], [email-masked], "David S. Miller" <[email-masked]>, "Alexey Kuznetsov" <[email-masked]>,
> "James Morris" <[email-masked]>, "Hideaki YOSHIFUJI" <[email-masked]>, "Patrick McHardy"
> <[email-masked]>, [email-masked]
> Sent: Saturday, October 12, 2013 1:37:34 PM
> Subject: Re: [PATCH v2 tip/core/rcu 07/13] ipv6/ip6_tunnel: Apply rcu_access_pointer() to avoid sparse false positive
> 
> On Sat, Oct 12, 2013 at 06:43:45PM +0200, Hannes Frederic Sowa wrote:
> > Regarding the volatile access, I hope that the C11 memory model
> > and enhancements to the compiler will some day provide a better
> > way to express the semantics of what is tried to express here
> > (__atomic_store_n/__atomic_load_n with the accompanied memory model,
> > which could be even weaker to what a volatile access would enfore
> > now and could guarantee atomic stores/loads).
> 
> I just played around a bit more. Perhaps we could try to warn of silly
> usages of ACCESS_ONCE():
> 
> --- a/include/linux/compiler.h
> +++ b/include/linux/compiler.h
> @@ -349,7 +349,11 @@ void ftrace_likely_update(struct ftrace_branch_data *f,
> int val, int expect);
>   * use is to mediate communication between process-level code and irq/NMI
>   * handlers, all running on the same CPU.
>   */
> -#define ACCESS_ONCE(x) (*(volatile typeof(x) *)&(x))
> +#define ACCESS_ONCE(x) (*({						\
> +		compiletime_assert(sizeof(typeof(x)) <= sizeof(typeof(&x)), \
> +				   "ACCESS_ONCE likely not atomic");	\

AFAIU, ACCESS_ONCE() is not meant to ensure atomicity of load/store, but rather merely ensures that the compiler will not merge nor refetch accesses. I don't think the assert check you propose is appropriate with respect to the ACCESS_ONCE() semantic.

Thanks,

Mathieu

> +		(volatile typeof(x) *)&(x);				\
> +}))
>  
>  /* Ignore/forbid kprobes attach on very low level functions marked by this
>  attribute: */
>  #ifdef CONFIG_KPROBES
> 
> 

-- 
Mathieu Desnoyers
EfficiOS Inc.
http://www.efficios.com